//microchip_solutions_v2013-06-15
#include <xc.h>
#include "i2c-lib.h"//YTS
#include "stdint.h"
#include "math.h"

#define EEPROM_I2C_ADDR 0x60

enum Outfreq { LOW, EXACT , HIGH } freq;

uint8_t msna[8]={0x00,0x01,0x00,0x06,0x00,0x00,0x00,0x00};

//20.05019 MHz
uint8_t mso_high[8]={0x27,0x76,0x00,0x07,0xf9,0x00,0x15,0x3a};
//20.00008 MHz
uint8_t mso_exact[8]={0x27,0x11,0x00,0x07,0xff,0x00,0x24,0x91};
//19.95021 MHz
uint8_t mso_low[8]={0x26,0xae,0x00,0x08,0x06,0x00,0x0c,0xec};
    
void SYSTEM_Initialize( void );


//Enternal I2C eeprom write test
void i2c_eeprom_write(unsigned char addr,unsigned char data){
	i2c_start();
	i2c_send_byte(EEPROM_I2C_ADDR << 1);// R/Wrbg(Write=0)// R/Wrbg(Write=0)
	i2c_send_byte(addr);// AhX
	i2c_send_byte(data);	//write from usart data
	i2c_stop();
//	__delay_ms(10);
	return;
}


//Enternal I2C eeprom read test
unsigned char i2c_eeprom_read_byte(unsigned char addr){
	unsigned char data;

	i2c_start();
	i2c_send_byte(EEPROM_I2C_ADDR<<1);  // R/Wrbg(Write=0)
	i2c_send_byte(addr);// AhX
	i2c_repeat_start();
	i2c_send_byte((EEPROM_I2C_ADDR<<1) | 1);// R/Wrbg(Read=1)
	data = i2c_read_byte(0);  // ǂݍ݌ ACK
	i2c_stop();

//	__delay_us(30);
	return (data);
}

 //*******************************************************************************************   
void set_clk(uint8_t mso[])
{
    i2c_enable();
    
    i2c_eeprom_write(0xb7,0x92);//XTAL_CL = 8pF
        
    i2c_eeprom_write(0x03,0xff); //Disable Output
    i2c_eeprom_write(0x10,0x80); //CLOCK0 Power down
        
    i2c_eeprom_write(0x1a,msna[0]);//MSNA_P3[15:8]
    i2c_eeprom_write(0x1b,msna[1]);//MSNA_P3[7:0]
    i2c_eeprom_write(0x1c,msna[2]);//MSNA_P1[17:16]
    i2c_eeprom_write(0x1d,msna[3]);//MSNA_P1[15:8]
    i2c_eeprom_write(0x1e,msna[4]);//MSNA_P1[7:0]
    i2c_eeprom_write(0x1f,msna[5]);//MSNA_P3[19:16]+MSNA_P2[19:16]
    i2c_eeprom_write(0x20,msna[6]);//MSNA_P2[15:8]
    i2c_eeprom_write(0x21,msna[7]);//MSNA_P2[7:0]
    
    i2c_eeprom_write(0x2a,mso[0]);//MS0_P3[15:8]
    i2c_eeprom_write(0x2b,mso[1]);//MS0_P3[7:0]
    i2c_eeprom_write(0x2c,mso[2]);//MS0_P1[17:16]
    i2c_eeprom_write(0x2d,mso[3]);//MS0_P1[15:8]
    i2c_eeprom_write(0x2e,mso[4]);//MS0_P1[7:0]
    i2c_eeprom_write(0x2f,mso[5]);//MS0_P3[19:16]+MS0_P2[19:16]
    i2c_eeprom_write(0x30,mso[6]);//MS0_P2[15:8]
    i2c_eeprom_write(0x31,mso[7]);//MS0_P2[7:0]
        
    i2c_eeprom_write(0xb1,0xa0);//Reset PLLA and PLLB
    i2c_eeprom_write(0x10,0x4f);//CLOCK0 Power up 8mA
    i2c_eeprom_write(0x03,0xfe);//Enable CLOCK0
    }

int main(void) {
          
    SYSTEM_Initialize();
    
    set_clk(mso_exact);
    LATCbits.LATC3=0;
    LATCbits.LATC4=1;
    LATCbits.LATC5=0;
    freq=HIGH;
    
    while(1);
}

//----------------------ݏ------------------------
void interrupt isr(void){
    if(IOCBFbits.IOCBF5){ 
        switch(freq){
            case LOW:
                set_clk(mso_low);
                LATCbits.LATC3=1;
                LATCbits.LATC4=0;
                LATCbits.LATC5=0;
                freq=EXACT;
                break;
            case EXACT:
                set_clk(mso_exact);
                LATCbits.LATC3=0;
                LATCbits.LATC4=1;
                LATCbits.LATC5=0;
                freq=HIGH;
                break;              
            case HIGH:
                set_clk(mso_high);
                LATCbits.LATC3=0;
                LATCbits.LATC4=0;
                LATCbits.LATC5=1;
                freq=LOW;
                break;
            default:
                break;
        }
         
        _delay(6000000UL); 
        while(PORTBbits.RB5==0);
        IOCBFbits.IOCBF5 = 0;             // 荞݃tbONA
   }
}

