/*
* 
* http://oasis.halfmoon.jp/mw/index.php?title=Elec-pic-i2c-common-library
* http://oasis.halfmoon.jp/cgi-bin/websvn/listing.php?repname=pic-i2c-lib
* File:   i2c-lib.c   for Microchip PIC XC8 (12F1822, 16F1823, 16F1827)
*/

#include <stdio.h>
#include <stdlib.h>

#include <xc.h>
#include "i2c-lib.h"

#ifndef _XTAL_FREQ
    /* F4MHz̏ꍇA4000000 Zbg */
//    #define _XTAL_FREQ 4000000
#endif

// I2CoXL
void i2c_enable(void)
{
    SSPSTAT = 0b10000000;      // I2C 100kHz
    SSPADD = 0x75;//9;         // I2CoX Baud rate,  16MHz/((SSP1ADD + 1)*4) = 100kHz
    SSPCON1 = 0b00101000;      // I2CL, Master Mode
}

// I2CoX𖳌
void i2c_disable(void){
    SSPCON1 = 0b00001000;      // I2C, Master Mode
}

// I2C݃TCN̊JniStart Condition̔sj
void i2c_start(void){
    SSPCON2bits.SEN = 1;       //  Start Condition Enabled bit
    i2c_wait();
}

// I2C݃TCN̊JniRepeat Start Condition̔sj
void i2c_repeat_start(void){
    SSPCON2bits.RSEN = 1;      //  Start Condition Enabled bit
    i2c_wait();
}

// I2C݃TCN̏IiStop Condition̔sj
void i2c_stop(void){
    SSPCON2bits.PEN = 1;       // Stop Condition Enable bit
    i2c_wait();
}

// I2CʐMrW[ԂE܂ő҂
void i2c_wait(void){
    while ( ( SSPCON2 & 0x1F ) || ( SSPSTATbits.R_nW ) );

}

// I2CoXɃf[^𑗐Mi1oCgj
void i2c_send_byte(const unsigned char data){
    SSPBUF = data;
    i2c_wait();
}

//I2CoXf[^M
// ack=1 : MACK𑗐MÃf[^𑗂悤X[ufoCXɎw
// ack=0 : MNO_ACK𑗐MAȏMȂƂX[ufoCXɎw
unsigned char i2c_read_byte(const char ack){
    SSPCON2bits.RCEN = 1;
    i2c_wait();
    unsigned char data = SSP1BUF;
    i2c_wait();

    if(ack) SSPCON2bits.ACKDT = 0;     // ACK
    else SSPCON2bits.ACKDT = 1;        // NO_ACK

    SSPCON2bits.ACKEN = 1;

    i2c_wait();
    return data;
}
